<script>
import { minValue, required, requiredIf } from 'vuelidate/lib/validators';
import { error_message, success_message } from '../../../Helper/helper';
import { paymentGatewayService } from '../../../services'


export default {
    props:['keyValue', 'gatewayId'],
    data() {
        return {
            openModal : false,
            errors:false,
            keyValues:[]
        };
    },
    mounted(){
        this.keyValues = this.keyValue
        this.getClientpaymentGateway();
        this.openModal = true
    },
    validations:{

    },
    methods: {
        getClientpaymentGateway(){
            paymentGatewayService.getClientPaymentGateway({gatewayId:this.gatewayId}).then((response) => {
                if (response.data.code === 200) {
                    if(response.data.result.length > 0){
                        this.keyValues = response.data.result;
                    }
                } else {
                    error_message(response.data.message);
                }
            })
        },

        itemModalClose(e) {            
            this.openModal = false;
            this.$emit('modalClose', false)
        },
        addKeys(e){
            const onlyInputs = document.querySelectorAll('#formData input');
            let formData = [];
            onlyInputs.forEach(input => {
                if(input.value == ''){
                    error_message('Please Enter '+input.name)
                }else{
                    formData.push({'key':input.id, 'value':input.value})
                }
            });
            if(this.keyValue.length == Object.keys(formData).length ){
                const fd = new FormData();
                fd.append('gatewayId', this.gatewayId);
                fd.append('keys', JSON.stringify(formData) );
                paymentGatewayService.storeClientPaymentGateway(fd).then((response) => {
                    if (response.data.code === 200) {
                        success_message(response.data.message);
                        this.$emit('modalClose', false)
                    } else {
                        error_message(response.data.message);
                    }
                })
            }
        }
    },

};
</script>


<template>
    <div>
        <b-modal v-model="openModal" hide-footer scrollable no-close-on-esc no-close-on-backdrop :title="trans.get('__JSON__.Add Item')" title-class="font-18" @hidden="itemModalClose" centered
        size="lg">
            <template v-if="keyValue.length > 0">
                <div>
                    <form @submit.prevent="addKeys" id="formData">
                        <div class="row">
                            <template v-for="(key,index) in keyValues">
                                <div class="col-md-6" :class="{'mt-3': index >= 2}">
                                    <h5 class="text-capitalize">{{ key.name}}</h5>
                                    <input type="text" class="form-control"  :name="key.name" :id="key.id" :value="key.value">
                                </div>
                            </template>
                        </div>
                        <hr>
                        <div class="row ">
                            <div class="col-md-12">
                                <div class="w-100">
                                    <b-button variant="primary" @click="addKeys" class="float-right add_item_" >
                                        {{ trans.get("__JSON__.Save") }}</b-button>
                                    <b-button class="float-left" @click="itemModalClose($event)">{{
                                        trans.get("__JSON__.Close")
                                    }}</b-button>
                                </div>
                            </div>
                        </div>
                    </form>
                </div>
            </template>
            <template v-else>
                <h6>{{ trans.get('__JSON__.Please Required Keys add') }}</h6>
            </template>
            <template slot="modal-footer">
                <div class="w-100">
                    <b-button variant="primary" class="float-right add_item_" >
                        {{ trans.get("__JSON__.Save") }}</b-button>
                    <b-button class="float-left" @click="itemModalClose($event)">{{
                        trans.get("__JSON__.Close")
                    }}</b-button>
                </div>
            </template>
        </b-modal>
    </div>
</template>